Index: trunk/NEMO/OPA_SRC/step.F90
===================================================================
--- trunk/NEMO/OPA_SRC/step.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/step.F90	(revision 508)
@@ -4,23 +4,23 @@
    !! Time-stepping    : manager of the ocean, tracer and ice time stepping
    !!======================================================================
-   !! History :
-   !!        !  91-03  ()  Original code
-   !!        !  91-11  (G. Madec)
-   !!        !  92-06  (M. Imbard)  add a first output record
-   !!        !  96-04  (G. Madec)  introduction of dynspg
-   !!        !  96-04  (M.A. Foujols)  introduction of passive tracer
-   !!   8.0  !  97-06  (G. Madec)  new architecture of call
-   !!   8.2  !  97-06  (G. Madec, M. Imbard, G. Roullet)  free surface
-   !!   8.2  !  99-02  (G. Madec, N. Grima)  hpg implicit
-   !!   8.2  !  00-07  (J-M Molines, M. Imbard)  Open Bondary Conditions
-   !!   9.0  !  02-06  (G. Madec)  free form, suppress macro-tasking
-   !!    "   !  04-08  (C. Talandier) New trends organization
-   !!    "   !  05-01  (C. Ethe) Add the KPP closure scheme
-   !!    "   !  05-11  (V. Garnier) Surface pressure gradient organization
-   !!    "   !  05-11  (G. Madec)  Reorganisation of tra and dyn calls
+   !! History :        !  91-03  ()  Original code
+   !!                  !  91-11  (G. Madec)
+   !!                  !  92-06  (M. Imbard)  add a first output record
+   !!                  !  96-04  (G. Madec)  introduction of dynspg
+   !!                  !  96-04  (M.A. Foujols)  introduction of passive tracer
+   !!             8.0  !  97-06  (G. Madec)  new architecture of call
+   !!             8.2  !  97-06  (G. Madec, M. Imbard, G. Roullet)  free surface
+   !!             8.2  !  99-02  (G. Madec, N. Grima)  hpg implicit
+   !!             8.2  !  00-07  (J-M Molines, M. Imbard)  Open Bondary Conditions
+   !!             9.0  !  02-06  (G. Madec)  free form, suppress macro-tasking
+   !!             " "  !  04-08  (C. Talandier) New trends organization
+   !!             " "  !  05-01  (C. Ethe) Add the KPP closure scheme
+   !!             " "  !  05-11  (V. Garnier) Surface pressure gradient organization
+   !!             " "  !  05-11  (G. Madec)  Reorganisation of tra and dyn calls
+   !!             " "  !  06-01  (L. Debreu, C. Mazauric)  Agrif implementation
+   !!             " "  !  06-07  (S. Masson)  restart using iom
    !!----------------------------------------------------------------------
    !!   stp            : OPA system time-stepping
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables 
@@ -30,4 +30,5 @@
    USE cpl_oce         ! coupled ocean-atmosphere variables
    USE in_out_manager  ! I/O manager
+   USE iom
    USE lbclnk
 
@@ -126,5 +127,4 @@
    PRIVATE
 
-   !! * Routine accessibility
    PUBLIC stp            ! called by opa.F90
 
@@ -135,13 +135,13 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-#if !defined key_agrif
+#if defined key_agrif
+   SUBROUTINE stp( )
+#else
    SUBROUTINE stp( kstp )
-#else
-   SUBROUTINE stp( )
 #endif
       !!----------------------------------------------------------------------
@@ -160,11 +160,10 @@
       !!              -7- Compute the diagnostics variables (rd,N2, div,cur,w)
       !!              -8- Outputs and diagnostics
-      !!
       !!----------------------------------------------------------------------
       !! * Arguments
-#if !defined key_agrif   
+#if defined key_agrif   
+      INTEGER               :: kstp   ! ocean time-step index
+#else
       INTEGER, INTENT( in ) :: kstp   ! ocean time-step index
-#else
-      INTEGER               :: kstp   ! ocean time-step index
 #endif      
 
@@ -176,10 +175,13 @@
       kstp = nit000 + Agrif_Nb_Step()
 !      IF ( Agrif_Root() .and. lwp) Write(*,*) '---'
-!      IF (lwp) Write(*,*) 'Grid N°',Agrif_Fixed(),' time step ',kstp
+!      IF (lwp) Write(*,*) 'Grid Number',Agrif_Fixed(),' time step ',kstp
 #endif   
       indic = 1                    ! reset to no error condition
+
       adatrj = adatrj + rdt/86400._wp
 
       CALL day( kstp )             ! Calendar
+
+      CALL rst_opn( kstp )         ! Open the restart file
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
@@ -326,5 +328,5 @@
                              CALL tra_ldf    ( kstp )       ! lateral mixing
 #if defined key_agrif
-      IF (.NOT. Agrif_Root())  CALL Agrif_Sponge_tra( kstp )          ! tracers sponge
+      IF(.NOT. Agrif_Root()) CALL Agrif_Sponge_tra( kstp )  ! tracers sponge
 #endif
                              CALL tra_zdf    ( kstp )       ! vertical mixing
@@ -363,5 +365,5 @@
                                CALL dyn_ldf( kstp )           ! lateral mixing
 #if defined key_agrif
-      IF (.NOT. Agrif_Root())  CALL Agrif_Sponge_dyn( kstp )         ! momemtum sponge
+      IF(.NOT. Agrif_Root())   CALL Agrif_Sponge_dyn( kstp )  ! momemtum sponge
 #endif
                                CALL dyn_hpg( kstp )           ! horizontal gradient of Hydrostatic pressure
@@ -400,15 +402,25 @@
 
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! Control, diagnostics and outputs
-      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      ! N.B. ua, va, ta, sa arrays are used as workspace in this section
-      !-----------------------------------------------------------------------
-
-      !                                            ! Time loop: control and print
-                       CALL stp_ctl( kstp, indic )
-                       IF ( indic < 0 ) CALL ctl_stop( 'step: indic < 0' ) 
-
-      IF ( nstop == 0 ) THEN
-         !                                         ! Diagnostics:
+      ! Control, and restarts
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      ! N.B. ua, va, ta, sa arrays are used as workspace in this section
+      !-----------------------------------------------------------------------
+      !                                                     ! Time loop: control and print
+                                 CALL stp_ctl( kstp, indic )
+      IF( indic < 0          )   CALL ctl_stop( 'step: indic < 0' )
+
+      IF( kstp == nit000     )   CALL iom_close( numror )             ! close input  ocean restart file
+      IF( lrst_oce           )   CALL rst_write  ( kstp )             ! write output ocean restart file
+      IF( lk_obc             )   CALL obc_rst_wri( kstp )             ! write open boundary restart file
+      IF( lk_trdmld          )   CALL trd_mld_rst_write( kstp )       ! ocean model: restart file output for trends diagnostics
+
+
+      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      ! diagnostics and outputs
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+      ! N.B. ua, va, ta, sa arrays are used as workspace in this section
+      !-----------------------------------------------------------------------
+
+      IF ( nstop == 0 ) THEN                                ! Diagnostics
          IF( lk_floats  )   CALL flo_stp( kstp )                 ! drifting Floats
          IF( lk_trddyn  )   CALL trd_dwr( kstp )                 ! trends: dynamics 
@@ -423,10 +435,6 @@
          IF( ln_diaptr  )   CALL dia_ptr( kstp )                 ! Poleward TRansports diagnostics
 
-         !                                         ! save and outputs
-                            CALL rst_write  ( kstp )             ! ocean model: restart file output
-         IF( lk_obc     )   CALL obc_rst_wri( kstp )             ! ocean model: open boundary restart file output
-         IF( lk_trdmld  )   CALL trd_mld_rst_write( kstp )       ! ocean model: restart file output for trends diagnostics
+         !                                                 ! Outputs
                             CALL dia_wri    ( kstp, indic )      ! ocean model: outputs
-
       ENDIF
 
@@ -436,5 +444,5 @@
 
       IF( lk_cpl    )   CALL cpl_stp( kstp )                 ! coupled mode : field exchanges
-
+      !
    END SUBROUTINE stp
 
